const webpack = require('webpack');

module.exports = {
  mode: 'development',
  devtool: 'source-map',
  module: {
    rule: {
      style: {
        test: /\.(less|css)$/,
        use: {
          'style-loader': {
            loader: require.resolve('style-loader'),
          },
          'css-loader': {
            loader: require.resolve('css-loader'),
            options: {
              sourceMap: false,
              modules: {
                auto: true,
                localIdentName: '[local]__[hash:base64:8]',
                exportLocalsConvention: 'camelCase',
              },
            },
          },
          'postcss-loader': {
            loader: require.resolve('postcss-loader'),
          },
          'less-loader': {
            loader: require.resolve('less-loader'),
            options: {
              sourceMap: false,
              lessOptions: {
                javascriptEnabled: true,
              },
            },
          },
        },
      },
    },
  },
  plugin: {
    hotModuleReplacementPlugin: {
      plugin: webpack.HotModuleReplacementPlugin,
    },
  },
};
