const Config = require('webpack-chain');
const webpack = require('webpack');
const path = require('path');
const localPath = require('../lib/local-path');

module.exports = function (env, config = {}) {
  return new Promise((resolve, reject) => {
    const isDev = env === 'dev';
    const baseConfig = require(path.join(__dirname, '../build/base.config'));
    const envConfig = isDev
      ? require(path.join(__dirname, '../build/dev.config'))
      : require(path.join(__dirname, '../build/prod.config'));
    const webpackConfig = new Config().merge(baseConfig).merge(envConfig);

    const ownMptCfg = require(localPath.resolve('./mopocket.config.js')) || {};
    ownMptCfg.hasOwnProperty('webpackChain') && ownMptCfg.webpackChain(webpackConfig);
    const compiler = webpack(webpackConfig.toConfig(), (err, stats) => {
      resolve(compiler);
      !isDev && console.log(stats.toString());
    });
  });
};
