const getPort = require('get-port');
const { getPkgName, isRootPath, resolve } = require('../lib/local-path');
const lodash = require('lodash');

module.exports = async (cfg) => {
  if (!isRootPath()) cfg.name = getPkgName();

  cfg.container = cfg.container || '#root';

  const defaultDevServer = {
    stats: 'minimal',
    contentBase: resolve(),
    publicPath: '/',
    host: '127.0.0.1',
    port: await getPort(),
    hot: true,
    headers: {
      'Access-Control-Allow-Origin': '*',
    },
    historyApiFallback: true,
    watchContentBase: false,
    liveReload: false,
    disableHostCheck: true,
    proxy: {},
  };
  cfg.devServer = cfg.devServer ? lodash.merge(defaultDevServer, cfg.devServer) : defaultDevServer;
  if (cfg.remoteMicroApps) {
    Object.keys(cfg.remoteMicroApps).forEach((key) => {
      cfg.devServer.proxy[`/${key}`] = cfg.remoteMicroApps[key].proxyPass;
    });
  }

  return cfg;
};
