const path = require('path');
const fs = require('fs');

const resolve = (pathUrl = '') => path.resolve(process.cwd(), pathUrl);
const cwd = process.cwd();

module.exports = {
  isLocalPath(templatePath) {
    return /^[./]|(^[a-zA-Z]:)/.test(templatePath);
  },

  getTemplatePath(templatePath) {
    return path.normalize(path.join(__dirname, '../templates', templatePath));
  },

  resolve,

  getPkgPath() {
    return cwd.slice(cwd.lastIndexOf(path.sep), cwd.length);
  },

  getPkgName() {
    return cwd.slice(cwd.lastIndexOf(path.sep) + 1, cwd.length);
  },

  isRootPath: () => fs.existsSync(resolve('./micro-apps'))
};
