import { registerMicroApps, start, setDefaultMountApp, FrameworkLifeCycles, loadMicroApp } from 'qiankun';
import { MicroComponentOptions, regApps, regComponents } from './index';

export const startMicroApps = (lifeCycles: FrameworkLifeCycles<any> = {}) => {
  registerMicroApps(regApps, lifeCycles);
  start();
};

export const loadMicroComponent = (options: MicroComponentOptions) => {
  const comp = regComponents.find((comp) => comp.name === options.name);
  if (!comp) throw new Error(`找不到name为${options.name}的微组件！`);
  return loadMicroApp({
    name: options.name,
    entry: comp.entry,
    container: options.container,
    props: options.props,
  });
};

export const setDefaultApp = setDefaultMountApp;
