const deserialize = require('mopocket/lib/deserialize');
const mptConfig = deserialize(process.env.MPT_CONFIG);
const { resolve } = require('mopocket/lib/local-path');

module.exports = {
  publicPath: process.env.NODE_ENV === 'production' ? `/${mptConfig.name}/` : '/',
  devServer: {
    host: mptConfig.devServer.host,
    port: mptConfig.devServer.port,
    headers: {
      'Access-Control-Allow-Origin': '*',
    },
  },
  chainWebpack: (webpackConfig) => {
    webpackConfig.output
      .library(`${mptConfig.name}-[name]`)
      .libraryTarget('umd')
      .jsonpFunction(`webpackJsonp_${mptConfig.name}`);

    webpackConfig.plugin('define').tap((args) => {
      return [
        {
          ...args[0],
          __MPT_CONFIG__: process.env.MPT_CONFIG,
          __MPT_REG_APPS__: process.env.MPT_REG_APPS,
          __MPT_REG_COMPS__: process.env.MPT_REG_COMPS,
        },
      ];
    });

    webpackConfig.resolve.alias
      .set('@', resolve('./src'))
      .set('@master', resolve('../../src'))
      .set('@micro-components', resolve('../../micro-components'))
      .set('@micro-apps', resolve('../../micro-apps'));
  },
};
